const dbconn = require('./dbconn');

var methods = {
    // test method
	currentDate: function() {
		console.log('Current Date is: ' + new Date().toISOString().slice(0, 10));
    },
    // ======================= user db =======================
	checkUserEmail: function(email, callback) {
        var user;
        dbconn.user.query('SELECT email FROM user WHERE email = "' +email+'"', function (err, rows, fields) {
            if (err) {
                throw err;
            }
            else {
                if ( rows.length > 0) {
                    user = rows[0];
                }
            }
            callback(err, user);
        });
    },
    checkUserToken: function(token, callback) {
        var user;
        dbconn.user.query('SELECT email FROM user WHERE resetPasswordToken = "'+token+'" and resetPasswordExpires > '+Date.now(), function (err, rows, fields) {
            if (err) {
                throw err;
            }
            else {
                if ( rows.length > 0) {
                    user = rows[0];
                }
            }
            callback(err, user);
        });
    },
	updateUser: function(userData, callback) {
		dbconn.user.query('UPDATE user SET ? WHERE email = "' +userData.email+'"', userData, function (err, rows, fields) {
            if (err) throw err;
            callback(err);
        })
    },
    updatePassword: function(hash, email, callback) {
		dbconn.user.query('UPDATE user SET password = "'+hash+'" WHERE email = "' +email+'"', function (err, rows, fields) {
            if (err) throw err;
            callback(err);
        })
    },
    getUserIdByEmail: function(email, callback) {
        var userId
        dbconn.user.query('SELECT id FROM user WHERE email = "' +email+'"', function (err, rows, fields) {
            if (err) {
                throw err;
            }
            else {
                if ( rows.length > 0) {
                    userId = rows[0].id;
                }
            }
            callback(userId, err);
        });
    },
    getUserProjectRole: function(userId, callback) {
        dbconn.user.query('SELECT project_id, role_id FROM user_project_role WHERE user_id = "' +userId+'"', function (err, rows, fields) {
            if (err) throw err;
            callback(rows, err);
        });
    },
    // ======================= project db =======================
    getAllProjects: function(callback) {
        dbconn.project.query('CALL getAllprojects', function (err, rows, fields){
            if (err) throw err;
            callback(rows[0], err);
        })
    }
};

module.exports = methods;